<template>
  <q-page class="q-px-md q-mt-md">
    <div class="row justify-center">
      <div class="col-12" style="max-width: 800px;">
        <q-card class="q-mb-md">
          <q-card-section>
            <div class="text-h6">Group Provider</div>
          </q-card-section>
        </q-card>
      </div>
    </div>
    <div class="row justify-center">
      <div class="col-12" style="max-width: 800px;">
        <q-card class="q-mb-md">
          <q-card-section>
            <div class="row">
              <div class="col-2 text-grey-6 text-right">
                Owner :
              </div>
              <div class="col q-pl-xs text-black">
                {{ group.member_created_name }}
              </div>
            </div>
            <div class="row">
              <div class="col-2 text-grey-6 text-right">
                Code :
              </div>
              <div class="col q-pl-xs text-black">
                {{ group.code }}
              </div>
            </div>
            <div class="row">
              <div class="col-2 text-grey-6 text-right">
                Name :
              </div>
              <div class="col q-pl-xs text-black">
                {{ group.name }}
              </div>
            </div>
            <div class="row">
              <div class="col-2 text-grey-6 text-right">
                Image :
              </div>
              <div class="col text-right">
                <q-img style="max-height: 128px;" contain :src="group.image" />
              </div>
            </div>
          </q-card-section>
        </q-card>
      </div>
    </div>
    <div class="row justify-center">
      <div class="col-12" style="max-width: 800px;">
        <!-- <q-table  :rows-per-page-options="[15, 25, 50]" 
          :pagination.sync="pagination"
          :columns="columns"
          :loading="loading"
          :filter="filter"
          :data="[{}]"
          separator="cell"
          row-key="id"
          @request="onRequest"
        >
          <template v-slot:top-left>
            <q-btn
              color="primary"
              label="Provider"
              icon="add"
              @click.prevent="modal = true"
            />
          </template>
          <q-tr slot="header" slot-scope="props" :props="props">
            <td :key="col.label" v-for="col in props.cols">
              {{ col.label }}
            </td>
          </q-tr>
          

          <q-tr slot="body" slot-scope="props" :props="props">
            <q-td>
              {{ props.row.code }}
            </q-td>
            <q-td>
              {{ props.row.provider_name }}
            </q-td>
            <q-td>
              <q-btn
                size="sm"
                round
                rounded
                icon="arrow_upward"
                @click="reorder('UP', props.row)"
                class="q-mr-xs"
              />
              <q-btn
                size="sm"
                round
                rounded
                icon="arrow_downward"
                @click="reorder('DOWN', props.row)"
                class="q-mr-xs"
              />
            </q-td>
            <q-td>
              <div class="q-gutter-xs">
                <q-btn
                  @click.prevent="onDelete(props.row)"
                  color="negative"
                  size="sm"
                  round
                  icon="delete"
                />
              </div>
            </q-td>
          </q-tr>
        </q-table> -->

        <q-markup-table class="col-12">
          <thead>
            <tr>
              <th class="text-left">Code</th>
              <th class="text-left">Name</th>
              <th class="text-center">Order</th>
              <th>Action</th>
            </tr>
          </thead>
          <draggable
            class="list-group"
            @change="handleMove"
            v-bind="dragOptions"
            v-model="data"
            tag="tbody"
            @start="drag = true"
            @end="drag = false"
          >
            <!-- <transition-group
              type="transition"
              :name="!drag ? 'flip-list' : null"
            > -->
            <tr
              type="transition"
              :name="!drag ? 'flip-list' : null"
              class="list-group-item"
              v-for="(item, index) in data"
              :key="index"
            >
              <td>
                {{ item.code }}
              </td>
              <td>
                {{ item.provider_name }}
              </td>
              <td class="text-center">
                <q-btn
                  size="sm"
                  round
                  rounded
                  icon="arrow_upward"
                  @click="reorder('UP', item)"
                  class="q-mr-xs"
                />
                <q-btn
                  size="sm"
                  round
                  rounded
                  icon="arrow_downward"
                  @click="reorder('DOWN', item)"
                  class="q-mr-xs"
                />
              </td>
              <td class="text-center">
                <div class="q-gutter-xs">
                  <q-btn
                    @click.prevent="onDelete(item)"
                    color="negative"
                    size="sm"
                    round
                    icon="delete"
                  />
                </div>
              </td>
            </tr>
            <!-- </transition-group> -->
          </draggable>

          <div class="q-pa-lg flex flex-end">
            <q-pagination
              v-model="pagination.page"
              :max="pagination.maxPage"
              @input="handleClickPagination"
            />
          </div>
        </q-markup-table>
      </div>
    </div>
    <q-dialog
      v-model="modal"
      persistent
      transition-show="flip-down"
      transition-hide="flip-up"
    >
      <q-card style="width: 700px; max-width: 800px;">
        <q-form @submit="onProviderSubmit">
          <q-bar>
            <q-btn dense flat icon="close" v-close-popup>
              <q-tooltip>Close</q-tooltip>
            </q-btn>
          </q-bar>
          <q-card-section>
            <q-select
              filled
              v-model="$v.providerForm.provider_id.$model"
              error-message="กรุณาเลือก Provider"
              :options="providerOptions"
              use-input
              hide-selected
              fill-input
              @filter="filterOptions"
              input-debounce="0"
              emit-value
              map-options
              :option-value="'id'"
              :option-label="opt => `${opt.code} - ${opt.name}`"
            >
            </q-select>
          </q-card-section>
          <q-card-actions align="right" class="bg-primary text-white">
            <q-btn push rounded color="primary" type="submit">Submit </q-btn>
            <q-btn push rounded color="primary" v-close-popup>Cancel</q-btn>
          </q-card-actions>
        </q-form>
      </q-card>
    </q-dialog>
  </q-page>
</template>
<script>
import { mapState, mapGetters, mapActions } from "vuex";
import { required } from "vuelidate/lib/validators";
import { delete_provider } from "src/store/group/v2/actions";
import draggable from "vuedraggable";

export default {
  name: "Group",
  components: {
    draggable
  },
  data() {
    return {
      group: {},
      filter: "",
      loading: false,
      pagination: {
        sortBy: "desc",
        descending: false,
        page: 1,
        rowsPerPage: 15,
        rowsNumber: 0,
        maxPage: 0
      },
      data: [],
      drag: false,
      columns: [
        { label: "Code", field: "code" },
        { label: "Name", field: "name" },
        { label: "Order", field: "order" },
        { label: "Action" }
      ],
      permissions: () => false,
      modal: false,
      providers: [],
      providerOptions: [],
      providerForm: {
        provider_id: undefined
      },
      firstLoad: true
    };
  },
  validations: {
    providerForm: {
      provider_id: {
        required
      }
    }
  },
  computed: {
    id() {
      return this.$route.params.id;
    },
    dragOptions() {
      return {
        animation: 0,
        group: "description",
        disabled: false,
        ghostClass: "ghost"
      };
    }
  },
  async created() {
    this.permissions = await this.initPermission("group");
    await this.load();
    await this.onRequest({
      pagination: this.pagination,
      filter: undefined
    });
    await this.initProvider();
  },
  watch: {
    modal(val) {
      if (val) {
        this.providerForm = {
          provider_id: undefined
        };
      }
    }
  },
  methods: {
    ...mapActions("permission", {
      initPermission: "permission"
    }),
    ...mapActions("group/v2", {
      load_group_by_id: "load",
      load_provider: "load_provider",
      add_provider: "add_provider",
      delete_provider: "delete_provider",
      arrange_provider: "arrange_provider"
    }),
    ...mapActions("provider", {
      load_provider_list: "load"
    }),
    async load() {
      if (this.id) {
        try {
          const { data } = await this.load_group_by_id(this.id);
          this.group = data;
        } catch (ex) {
          this.$dialog.errorException(ex);
        }
      } else {
        this.edit = false;
      }
    },
    async onRequest(props) {
      this.$q.loading.show();

      const { page, rowsPerPage, sortBy, descending } = props.pagination;
      const filter = props.filter;
      this.loading = true;
      const {
        data: { results, page: resultPage, per_page, total }
      } = await this.load_provider({
        id: this.id,
        pagination: {
          page: page,
          page_limit: rowsPerPage
        }
      });

      // clear out existing data and add new
      this.data.splice(0, this.data.length, ...results);

      // don't forget to update local pagination object
      this.pagination.page = resultPage;
      this.pagination.rowsPerPage = per_page;
      this.pagination.rowsNumber = total;
      this.pagination.sortBy = sortBy;
      this.pagination.descending = descending;
      this.pagination.maxPage = Math.ceil(+total / +per_page);
      this.loading = false;
      this.$q.loading.hide();
    },
    async reorder(flag, row) {
      const currentIndex = this.data.findIndex(x => x.id == row.id);
      let newIndex = 0;
      if (flag.toUpperCase() == "UP") {
        this.data[currentIndex - 1].order = currentIndex;
        newIndex = this.data[currentIndex].order - 1;
        this.data[currentIndex].order = newIndex;
      } else if (flag.toUpperCase() == "DOWN") {
        this.data[currentIndex + 1].order = currentIndex;
        newIndex = this.data[currentIndex].order + 1;
        this.data[currentIndex].order = newIndex;
      }
      try {
        const response = await this.arrange_provider({
          id: this.id,
          provider_id: row.id,
          position: newIndex
        });
        await this.onRequest({
          pagination: this.pagination,
          filter: undefined
        });
      } catch (ex) {
        this.$dialog.errorException(ex);
      }
    },
    async initProvider() {
      const { data } = await this.load_provider_list();
      this.providers = data;
      this.providerOptions = data;
    },
    async onProviderSubmit() {
      this.$v.providerForm.$touch();
      this.$q.loading.show();
      if (this.$v.providerForm.$invalid) {
        this.$q.loading.hide();
        return;
      }
      try {
        const { data } = await this.add_provider({
          id: this.id,
          provider_id: this.providerForm.provider_id
        });
        await this.onRequest({
          pagination: this.pagination,
          filter: undefined
        });
        this.$q.loading.hide();
        this.modal = false;
      } catch (ex) {
        this.$dialog.errorException(ex);
        this.$q.loading.hide();
      }
    },
    async onDelete(row) {
      this.$q
        .dialog({
          title: "Alert",
          message: `คุณต้องการลบ Provider ${row.name} ออกจาก Group หรือไม่`,
          ok: {
            color: "negative",
            label: "ลบ"
          },
          cancel: {
            flat: true,
            label: "ไม่"
          }
        })
        .onOk(async () => {
          try {
            this.$q.loading.show();
            await this.delete_provider({ id: this.id, provider_id: row.id });
            await this.onRequest({
              pagination: this.pagination,
              filter: undefined
            });
            this.$q.loading.hide();
          } catch (ex) {
            this.$dialog.errorException(ex);
            this.$q.loading.hide();
          }
        });
    },
    async handleClickPagination() {
      if (this.firstLoad) {
        this.firstLoad = false;
        return;
      }
      await this.onRequest({
        pagination: this.pagination,
        filter: undefined
      });
    },

    async handleMove(value) {
      try {
        const response = await this.arrange_provider({
          id: this.id,
          provider_id: value.moved.element.id,
          position: value.moved.newIndex
        });
        await this.onRequest({
          pagination: this.pagination,
          filter: undefined
        });
      } catch (ex) {
        this.$dialog.errorException(ex);
      }
    },
    filterOptions(val, update, abort) {
      update(() => {
        const needle = val.toLowerCase();
        if (needle) {
          this.providerOptions = this.providers.filter(
            v => `${v.code} - ${v.name}`.toLowerCase().indexOf(needle) > -1
          );
        } else {
          this.providerOptions = this.providers;
        }
      });
    }
  }
};
</script>
<style lang="scss" scoped>
.button {
  margin-top: 35px;
}
.flip-list-move {
  transition: transform 0s;
}
.no-move {
  transition: transform 0s;
}
.ghost {
  opacity: 0.8;
  background: #c4b0ec;
}
.list-group {
  min-height: 20px;
}
.list-group-item {
  cursor: move;
}
.list-group-item i {
  cursor: pointer;
}
</style>
